set ns [new Simulator]

set nf [open out.nam w]
$ns namtrace-all $nf
set tf [open out.tr w]
$ns trace-all $tf

set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]
set n4 [$ns node]
set n5 [$ns node]
set n6 [$ns node]
set n7 [$ns node]
set n8 [$ns node]
set n9 [$ns node]
set n10 [$ns node]
set n11 [$ns node]
set n12 [$ns node]
set n13 [$ns node]

$ns duplex-link $n0 $n2 2Mb 10ms DropTail
$ns duplex-link $n1 $n2 2Mb 10ms DropTail
$ns duplex-link $n2 $n3 2Mb 10ms DropTail
$ns duplex-link $n2 $n5 0.5Mb 50ms DropTail
$ns duplex-link $n4 $n5 2Mb 20ms DropTail
$ns duplex-link $n5 $n6 2Mb 30ms DropTail
$ns duplex-link $n5 $n8 0.4Mb 50ms DropTail
$ns duplex-link $n7 $n8 2Mb 10ms DropTail
$ns duplex-link $n8 $n9 2Mb 30ms DropTail
$ns duplex-link $n8 $n11 0.5Mb 50ms DropTail
$ns duplex-link $n11 $n12 2Mb 1ms DropTail
$ns duplex-link $n11 $n10 2Mb 10ms DropTail
$ns duplex-link $n11 $n13 2Mb 10ms DropTail

set tcp [new Agent/TCP/Vegas]     
set sink [new Agent/TCPSink] 
$ns attach-agent $n0 $tcp
$ns attach-agent $n13 $sink
$ns connect $tcp $sink
set ftp [new Application/FTP]
$ftp attach-agent $tcp
$ns at 1.0 "$ftp start"

set udp1 [new Agent/UDP]
$ns attach-agent $n1 $udp1
set udp3 [new Agent/UDP]
$ns attach-agent $n3 $udp3
set udp4 [new Agent/UDP]
$ns attach-agent $n4 $udp4
set udp9 [new Agent/UDP]
$ns attach-agent $n9 $udp9

set cbr1 [new Application/Traffic/CBR]
$cbr1 set packetSize_ 500
$cbr1 set interval_ 0.02
$cbr1 attach-agent $udp1

set cbr3 [new Application/Traffic/CBR]
$cbr3 set packetSize_ 500
$cbr3 set interval_ 0.02
$cbr3 attach-agent $udp3

set cbr4 [new Application/Traffic/CBR]
$cbr4 set packetSize_ 500
$cbr4 set interval_ 0.02
$cbr4 attach-agent $udp4

set cbr9 [new Application/Traffic/CBR]
$cbr9 set packetSize_ 500
$cbr9 set interval_ 0.02
$cbr9 attach-agent $udp9

set null6 [new Agent/Null] 
$ns attach-agent $n6 $null6
set null7 [new Agent/Null] 
$ns attach-agent $n7 $null7
set null10 [new Agent/Null] 
$ns attach-agent $n10 $null10
set null12 [new Agent/Null] 
$ns attach-agent $n12 $null12

$ns connect $udp1 $null7
$ns connect $udp3 $null6
$ns connect $udp4 $null10
$ns connect $udp9 $null12

$ns at 0.5 "$cbr1 start"
$ns at 1.5 "$cbr3 start"
$ns at 2.5 "$cbr4 start"
$ns at 3.5 "$cbr9 start"
$ns at 199.5 "$cbr1 stop"
$ns at 198.5 "$cbr3 stop"
$ns at 197.5 "$cbr4 stop"
$ns at 196.5 "$cbr9 stop"
$ns at 199.0 "$ftp stop"

proc finish {} {
	global ns nf
	$ns flush-trace
	close $nf
	exec nam out.nam &
	exit 0 }

set loss_module [new ErrorModel]
$loss_module set rate_ 0.2
$loss_module ranvar [new RandomVariable/Uniform]
$loss_module drop-target [new Agent/Null]
$ns lossmodel $loss_module $n5 $n8

$ns at 200.0 "finish"

$ns run

